<?php
/* C_page.php
* $db = new mysql("localhost","root","roort","dbname","utf8"); //实例化数据库类
* $sql = "SELECT * FROM article order by article_id desc"; //sql语句
* $page = new page($sql,7,"index.php?"); //实例化分页类
* $sql = $page->pagesql(); //格式化sql语句
* $result = $db->query($sql);
* while($row=$db->fetch_array($result)) {
* echo $row["article_id"].$row["article_title"]."<br />";
* }
* echo $page->show(); //输出html
* $db->close();
* ====================================================
*/
class multipage{
  private $url;
  private $pagesize; //每页要显示的记录数
  private $sql; //sql语句
  private $getpage; //当前页数

//参数:sql语句，每页记录数，传递链接(例如"index.php?"或者"index.php?sort=1&"等)
//输出的url为index.php?page=23或者index.php?type=1&page=2
//意思为第23页或者第1类的第2页
//开始初始化
  function __construct($sql,$pagesize,$url) {
    $this->url = $url;
    $this->pagesize = $pagesize;
    $this->sql = $sql;
    $this->getpage = intval( $_GET['page'] ); //page值由url传递，例如list.php?page=2
    if(!$this->getpage) { //检查是否传递了page值，如果没有则设置为1
      $this->getpage=1;
    }
  }

//获取记录总条数
  function getcount() {
    return mysql_num_rows(mysql_query($this->sql));
  }

//格式化sql语句
  function pagesql() {
    $nowpage = $this->getpage; //当前页号
    $limitNumber= $this->pagesize; //每页记录数
    if($nowpage<1) { //如果不是合法页号，则设置为第一页，如果超出了最后一页是不是应该同样操作？？？？
      $nowpage=1;
    }
    return $this->sql." limit ".($nowpage-1)*$limitNumber.",".$limitNumber;
//对sql语句处理，加上limit算法 select * from table limit offset,rows
// 1-10,11-20,21-30
//如每页显示10条，那么第3页就要显示第30-39间的10条，就是 select * from `table` limit 20,10
  }

//显示分页,参数:显示数字链接个数，偏移量
//$offset的作用是如果当前页号是4，那么分页条中就会显示从（4-2=2）开始的5页的链接
//那么，要显示的练级的页号就是从2开始到6，即4-2=2到4+5-2-1=6
//分页条的结构是 offset+1+（page-offset-1）=page
  function show($page = 5,$offset = 2){ //page是要显示的数字链接的个数，如果页数太多，不能全部显示，只显示一部分
    $mpurl = $this->url; //默认url，就是除去页号变量的部分
    $curr_page = $this->getpage; //当前页号
    $perpage = $this->pagesize; //每页记录数
    $num=$this->getcount(); //调用本类中的getcount函数，获得总记录数
    $multipage = ''; //初始化分页代码html内容

//如果总记录数大于每页显示的记录数，也就是说一页以上
    if ($num> $perpage){
      $totalpage = ceil($num / $perpage); //pages总页数=总记录数/每页记录数
      $from = $curr_page - $offset; //分页条开始页号
      $to = $curr_page + $page - $offset - 1; //分页条结束页号
//------------------------------------------------------------------------------------------------
      if ($page> $totalpage){ //如果初始的分页条显示的链接数大于 总页数
        $from = 1; //即 不足以填充满一个分页条的情况下
        $to = $totalpage; //最后一个链接就是总页数
      }else{
//------------------------------------------------------------------------------------------------
//下面讨论的是当一个分页条的链接数不能完整的显示出所有的页号时
//如 上一页……3 4 5 6 7……下一页 当前为第5页，共有记录100条，20页
//------------------------------------------------------------------------------------------------
//第一种特殊情况 如 上一页 1 2 3 4 5……下一页 当前为第1页的情况下
//这样计算出来的$from<1甚至小于0
        if ($from <1){ //当前页号是1的时候，如果继续按照上面的算法，$from页号会是-1，这要求在$from<1时，重新初始化$from=1
          $to = $curr_page + 1-$from; //计算结束页号
//这里的$from=$curpage - $offset
//$to为什么要等于$curpage + 1 - $from 呢？
//这里的$to的值永远是$offset+1
//为什么不直接给$to一个常量或什么呢？
          $from = 1; //重新设置开始页号，因为$from<1是不合法的
          if (($to - $from) <$page && ($to - $from) <$totalpage){ //如果分页条显示的链接数小于预设值和总页数
            $to = $page; //结束页号设置为$page
          }
//------------------------------------------------------------------------------------------------
//下面的情况是当前页为最后页的情况，处理同上
        }elseif ($to> $totalpage){ //
          $from = $curr_page - $totalpage + $to; //
          $to = $totalpage; //
          if (($to - $from) <$page && ($to - $from) <$totalpage){ //
            $from = $totalpage - $page + 1; //
          }
        }
      }
//开始定义输出


      $multipage .= '<div class="pagebar">';
      $multipage .= '<span>'.$num.'</span>';
      $multipage .= '<span>'.$curr_page.'/'.$totalpage.'</span>';
      if ($curr_page - $offset> 1){
        $multipage .= '<li><a href="'.$mpurl.'page=1" title="首页">首页</a></li> ';
        $prev_page =$curr_page-1;
        $multipage .='<li><a href="'.$mpurl.'page='.$prev_page.'title="上一页">上一页</a></li> ';
      }
      for ($i = $from; $i <= $to; $i++){
        if ($i != $curr_page){
          $multipage .='<li><a href="'.$mpurl.'page='.$i.'" title="第'.$i.'页">'.$i.'</a></li> ';
        }else{
          $multipage .= '<li> <span class="pcurpage">'.$i.'</span></li>';//当前页不用带超链接
        }
      }
      if ($curr_page + $offset <$totalpage){
        $next_page =$curr_page-1;
        $multipage .='<li><a href="'.$mpurl.'page='.$next_page.'title="下一页">下一页</a></li> ';
        $multipage .= '<li><a href="'.$mpurl.'page='.$totalpage.'" title=“尾页”>尾页</a></li>';
      }
      $multipage .='</div>';
    }
    return $multipage;
  }
}
//输出结构为 首页 上一页 2 3 4 5 6 下一页 尾页
?>